package com.muyu.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.domain.Vehicle;
import com.muyu.mapper.VehicleMapper;
import com.muyu.service.VehicleService;
import com.muyu.utils.VehicleUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.stream.Stream;

/**
 * <p>
 * 车辆 服务实现类
 * </p>
 *
 * @author DongZeLiang
 * @since 2022-07-05
 */
@Service
public class VechileServiceImpl extends ServiceImpl<VehicleMapper, Vehicle> implements VehicleService {

    /**
     * 根据数量生成测试车辆
     *
     * @param sum 数量
     */
    @Override
    @Transactional
    public void generate(Integer sum) {
        List<Vehicle> vehicleList = Stream.generate(Vehicle::gen).limit(sum).toList();
        this.saveBatch(vehicleList);
    }


}
