package com.muyu.vehicle.core;

import com.muyu.vehicle.VehicleInstance;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author DongZl
 * @description: 车辆容器
 * @Date 2023-11-16 下午 02:30
 */
public class LocalContainer {

    /**
     * 车辆容器
     */
    public static final Map<String, VehicleInstance> vehicleDataMap = new HashMap<>();

    /**
     * 添加车辆
     * @param vehicleInstance 车辆信息
     */
    public static void setVehicleInstance(List<VehicleInstance> vehicleInstance){
        vehicleInstance.forEach(LocalContainer::setVehicleInstance);
    }
    public static void setVehicleInstance(VehicleInstance vehicleInstance){
        String vin = vehicleInstance.getVehicle().getVin();
        if (!vehicleDataMap.containsKey(vin)) {
            vehicleDataMap.put(vin, vehicleInstance);
        }
    }

    /**
     * 获取车辆信息
     * @param vin vin
     * @return 车辆实例
     */
    public static VehicleInstance getVehicleInstance(String vin){
        return vehicleDataMap.get(vin);
    }

}
