package com.muyu.vehicle.core;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.muyu.domain.Vehicle;
import com.muyu.service.VehicleInstanceService;
import com.muyu.service.VehicleService;
import com.muyu.vehicle.VehicleInstance;
import com.muyu.vehicle.model.VehicleData;
import com.muyu.vehicle.model.properties.MqttProperties;
import lombok.AllArgsConstructor;
import lombok.extern.log4j.Log4j2;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.context.annotation.Configuration;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @author DongZeLiang
 * @version 1.0
 * @description 配置
 * @date 2023/11/9
 */
@Log4j2
@Configuration
@AllArgsConstructor
public class VehicleConfiguration implements ApplicationRunner {

    private final VehicleService vehicleService;

    private final VehicleInstanceService vehicleInstanceService;

    /*public VehicleInstance init(Vehicle vehicle){
        log.info("构建车辆对象: [{}]", vehicle.getVin());
        VehicleInstance vehicleInstance = new VehicleInstance(
                MqttProperties.builder()
                        .broker("tcp://fluxmq.muyu.icu:1883")
                        .topic("test")
                        .clientId(vehicle.getVin())
                        .build()
        );
        log.info("构建车辆实例: [{}]", vehicle.getVin());
        vehicleInstance.setVehicle(vehicle);
        vehicleInstance.setVehicleData(VehicleData.vehicleBuild(vehicle));
        vehicleInstance.initCline();
        log.info("构建车辆客户端: [{}]", vehicle.getVin());
        return vehicleInstance;
    }*/

    /**
     * 初始化加载汽车数据到内存当中
     */
    public void vehiclePageInit (){
        long startTime = System.currentTimeMillis();
        int page = 0, pageSize = 10;
        log.info("初始开始，批量从数据库当中加载数据到内存当中,每次[{}]条", pageSize);
        while (true){
            Page<Vehicle> vehiclePage = vehicleService.page(new Page<>(page++, pageSize));
            List<Vehicle> vehicleList = vehiclePage.getRecords();
            vehicleList.forEach(vehicleInstanceService::init);
            log.info("第[{}]页，[{}]条", page, vehicleList.size());
            if (vehicleList.size() < pageSize){
                break;
            }
        }
        log.info("数据加载完成，耗时：{} MS", System.currentTimeMillis() - startTime);
    }

    @Override
    public void run (ApplicationArguments args) {
        this.vehiclePageInit();
    }
}
